/*
 * Daneel - Dalvik to Java bytecode compiler
 * Copyright (C) 2011  IcedRobot team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * This file is subject to the "Classpath" exception:
 *
 * Linking this library statically or dynamically with other modules is
 * making a combined work based on this library.  Thus, the terms and
 * conditions of the GNU General Public License cover the whole
 * combination.
 *
 * As a special exception, the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent
 * modules, and to copy and distribute the resulting executable under terms
 * of your choice, provided that you also meet, for each linked independent
 * module, the terms and conditions of the license of that module.  An
 * independent module is a module which is not derived from or based on
 * this library.  If you modify this library, you may extend this exception
 * to your version of the library, but you are not obligated to do so.  If
 * you do not wish to do so, delete this exception statement from your
 * version.
 */

package org.icedrobot.daneel.rewriter;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;

import org.icedrobot.daneel.DexifyingRunner;
import org.junit.Test;
import org.junit.runner.RunWith;

@org.junit.Ignore("Switches not yet implemented")
@RunWith(DexifyingRunner.class)
public class SwitchTest {

    @Test
    public void testSwitchPacked() {
        assertEquals("A", DEXCode.switchPacked(7));
        assertEquals("B", DEXCode.switchPacked(8));
        assertEquals("B", DEXCode.switchPacked(9));
        assertEquals("C", DEXCode.switchPacked(10));
        assertEquals("C", DEXCode.switchPacked(11));
        assertNull(DEXCode.switchPacked(23));
    }

    @Test
    public void testSwitchSparse() {
        assertEquals("A", DEXCode.switchSparse(7));
        assertEquals("B", DEXCode.switchSparse(23));
        assertEquals("B", DEXCode.switchSparse(42));
        assertEquals("C", DEXCode.switchSparse(127));
        assertEquals("C", DEXCode.switchSparse(128));
        assertNull(DEXCode.switchSparse(129));
    }

    // Keep this class named "DEXCode" to push it through Daneel.
    private static class DEXCode {

        public static String switchPacked(int key) {
            switch (key) {
            case 7:
                return "A";
            case 8:
            case 9:
                return "B";
            case 10:
            case 11:
                return "C";
            }
            return null;
        }

        public static String switchSparse(int key) {
            switch (key) {
            case 7:
                return "A";
            case 23:
            case 42:
                return "B";
            case 127:
            case 128:
                return "C";
            }
            return null;
        }
    };
}
